<template>
  <div class="h-full w-full">
    <TableHeader>
      <div slot="left">
        <el-button size="small" type="primary" @click="handleAdd"
          >新增</el-button
        >
        <el-button size="small" type="danger" @click="handleDelAll"
          >批量删除</el-button
        >
      </div>
      <div slot="right">
        <el-form ref="searchForm" :model="searchForm" inline>
          <el-form-item prop="systemName">
            <el-input
              size="small"
              v-model="searchForm.systemName"
              style="width: 200px"
              class="ml10 mr10"
              placeholder="请输入系统名称搜索"
              @keyup.native.enter="handleSearch"
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-button size="small" type="primary" @click="handleSearch"
              >搜 索</el-button
            >
          </el-form-item>
          <el-form-item>
            <el-button size="small" @click="handleReset">重 置</el-button>
          </el-form-item>
        </el-form>
      </div>
    </TableHeader>
    <!-- 表格 -->
    <div class="table-content">
      <y-table
        ref="MyTable"
        :loading="loading"
        :data="tableData"
        :column="column"
        border
        tooltip-effect="dark"
        :max-height="600"
        :row-key="(row) => row.id"
        @selection-change="handleSelectionChange"
      ></y-table>
    </div>
    <Pagination
      :total="total"
      :page.sync="page"
      :pageSize.sync="size"
      @change="getSystemList"
    ></Pagination>
    <!-- 新增 -->
    <AddAreaSystem
      ref="AddAreaSystem"
      :show.sync="show"
      :title="title"
      @success="getSystemList"
    ></AddAreaSystem>
  </div>
</template>

<script>
import TableHeader from "@/components/TableHeader.vue";
import { getSystemList, deleteSystem } from "@/api/system";
import AddAreaSystem from "./components/AddAreaSystem.vue";
export default {
  components: {
    TableHeader,
    AddAreaSystem,
  },
  data() {
    return {
      column: [
        {
          label: "全选",
          type: "selection",
          width: "55",
          align: "center",
          reserveSelection: true,
        },
        {
          label: "序号",
          type: "index",
          width: "55",
          align: "center",
          index: (index) => {
            return (this.page - 1) * this.size + index + 1;
          },
        },

        {
          label: "系统名称",
          prop: "systemName",
          align: "center",
        },
        {
          label: "系统编码",
          prop: "systemCode",
          align: "center",
        },
        {
          label: "创建时间",
          align: "center",
          formatter: (row) => {
            if (row.createTime) {
              return this.$moment(row.createTime).format("YYYY-MM-DD HH:mm:ss");
            }
          },
        },
        {
          label: "排序",
          prop: "sort",
          align: "center",
        },
        {
          label: "备注",
          prop: "remark",
          align: "center",
        },
        {
          label: "操作",
          align: "center",
          width: "120",
          formatter: (row) => {
            return (
              <div class="flex justify-center gap-4">
                <span
                  class="primary cursor-pointer"
                  onClick={() => this.handleEdit(row)}
                >
                  编辑
                </span>
                <span
                  class="delete cursor-pointer"
                  onClick={() => this.handleDel(row.id)}
                >
                  删除
                </span>
              </div>
            );
          },
        },
      ],
      searchForm: {
        systemName: "",
      },
      tableData: [],
      page: 1,
      size: 10,
      total: 0,
      loading: false,
      selectRows: [],
      show: false,
      title: "新增",
      dict: {}, // 字典
    };
  },
  created() {
    this.getSystemList();
  },
  computed: {},
  methods: {
    // 获取接入区域列表
    async getSystemList() {
      this.loading = true;
      let res = await getSystemList({
        page: this.page,
        size: this.size,
        systemName: `%${this.searchForm.systemName}%`,
      });
      this.loading = false;
      if (res.data.code == 1) {
        let { data, total, dict } = res.data.data;
        if (!data.length && this.page > 1) {
          this.page -= 1;
          this.getSystemList();
        }
        this.tableData = data;
        this.total = total;
        this.dict = dict;
      }
    },
    // 批量移除
    handleDelAll() {
      if (!this.selectRows.length) {
        this.$message.warning("请先勾选数据");
        return;
      }
      let ids = this.selectRows.map((v) => v.id).join(",");
      this.handleDel(ids);
    },
    // 搜索
    handleSearch() {
      this.page = 1;
      this.$clearSelection("MyTable");
      this.getSystemList();
    },
    // 重置
    handleReset() {
      this.page = 1;
      this.$clearSelection("MyTable");
      this.$resetForm("searchForm");
      this.getSystemList();
    },
    // 选中
    handleSelectionChange(select) {
      this.selectRows = select;
    },

    // 新增
    handleAdd() {
      this.title = "新增";
      this.$refs.AddAreaSystem.onAdd();
      this.show = true;
    },
    // 编辑
    handleEdit(row) {
      this.title = "编辑";
      let data = this.$cloneDeep(row);
      this.$refs.AddAreaSystem.onEdit(data);
      this.show = true;
    },
    // 移除
    handleDel(id) {
      this.$confirm("此操作将删除所选数据，是否继续？", "系统提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        cancelButtonClass: "btn-custom-cancel",
        type: "warning",
      })
        .then(async () => {
          let res = await deleteSystem({ id });
          let { code, msg } = res.data;
          if (code === 1) {
            this.$message.success(msg);
            this.getSystemList();
            this.$clearSelection("MyTable");
          }
        })
        .catch(() => {
          console.log("取消成功！");
        });
    },
  },
};
</script>

<style lang="less" scoped></style>
